import tkinter as tk

morse_kod_list = {"a": "._", "b": "_...", "c": "_._.", "d": "_..", "e": ".", "f": ".._.",
                     "g": "__.", "h": "....", "i": "..", "j": ".___", "k": "_._", "l": "._..",
                     "m": "__", "n": "_.", "o": "___", "p": ".__.", "q": "__._", "r": "._.",
                     "s": "...", "t": "_", "u": ".._", "v": "..._", "w": ".__", "x": "_.._",
                     "y": "_.__", "z": "__..", "1": ".____", "2": "..___", "3": "...__",
                     "4": "...._", "5": ".....", "6": "_....", "7": "__...", "8": "___..",
                     "9": "____.", "0": "_____", "ä": "._._", "ö": "___.", "ü": "..__",
                     ".": "._._._", ",": "__..__", ":": "___...", ";": "_._._.", "?": "..__..",
                     "-": "_...._", "(": "_.__.", ")": "_.__._", "'": ".____.", "=": "_..._",
                     "+": "._._.", "/": "_.._.", "@": ".__._."}


class MorseTranslatorApp:
    def __init__(self, root):
        self.root = root
        self.root.title("Prekladač morzeovky")

        self.label = tk.Label(root, text="Zadaj text v latinke alebo v morzeovke:")
        self.label.pack(pady=10)

        self.input_text = tk.Entry(root)
        self.input_text.pack(pady=5)

        self.translate_button = tk.Button(root, text="Preklad", command=self.translate)
        self.translate_button.pack(pady=5)

        self.result_label = tk.Label(root, text="")
        self.result_label.pack(pady=10)

    def translate(self):
        text = self.input_text.get().strip()

        if text.startswith(".") or text.startswith("_"):
            translated_text = self.morse_do_text(text)
        else:
            translated_text = self.text_do_morse(text)

        self.result_label.config(text=translated_text)

    def text_do_morse(self, text):
        morse_kod = ''
        for znak in text.lower():
            if znak in morse_kod_list:
                morse_kod += morse_kod_list[znak] + ' '
            else:
                morse_kod += '  '
        return morse_kod

    def morse_do_text(self, morse_kod):
        morse_kod = morse_kod.split(' ')
        text = ''
        capitalize_next = True
        for kod in morse_kod:
            if kod == '':
                text += ' '
            else:
                for key, value in morse_kod_list.items():
                    if kod == value:
                        if capitalize_next:
                            text += key.upper()
                            capitalize_next = False
                        else:
                            text += key
                        if kod == "._._._":
                            capitalize_next = True
                        elif kod == "..__..":
                            capitalize_next = True
        return text


if __name__ == "__main__":
    root = tk.Tk()
    app = MorseTranslatorApp(root)
    root.mainloop()
