import time
import os
import random

morse_kod_dictionary = {"a": "._", "b": "_...", "c": "_._.", "d": "_..", "e": ".", "f": ".._.", "g": "__.", "h": "....", "i": "..", "j": ".___", "k": "_._", "l": "._..", "m": "__", "n": "_.", "o": "___", "p": ".__.", "q": "__._", "r": "._.", "s": "...", "t": "_", "u": ".._", "v": "..._", "w": ".__", "x": "_.._", "y": "_.__", "z": "__..", "1": ".____", "2": "..___", "3": "...__", "4": "...._", "5": ".....", "6": "_....", "7": "__...", "8": "___..", "9": "____.", "0": "_____", "ä": "._._", "ö": "___.", "ü": "..__", ".": "._._._", ",": "__..__", ":": "___...", ";": "_._._.", "?": "..__..", "-": "_...._", "(": "_.__.", ")": "_.__._", "'": ".____.", "=": "_..._", "+": "._._.", "/": "_.._.", "@": ".__._."}


def text_do_morse(text):
    morse_kod = ''
    for znak in text.lower():
        if znak in morse_kod_dictionary:
            morse_kod += morse_kod_dictionary[znak] + ' '
        else:
            morse_kod += '  '
    return morse_kod


def morse_do_text(morse_kod):
    morse_kod = morse_kod.split(' ')
    text = ''
    capitalize_next = True
    for kod in morse_kod:
        if kod == '':
            text += ' '
        else:
            for key, value in morse_kod_dictionary.items():
                if kod == value:
                    if capitalize_next:
                        text += key.upper()
                        capitalize_next = False
                    else:
                        text += key
                    if kod == "._._._":
                        capitalize_next = True
                    elif kod == "..__..":
                        capitalize_next = True
    return text


def main():
    while True:
        os.system('cls')
        print("__________________________________________________________")
        print("| Prekladač morzeovky v1.0                                |")
        print("==========================================================")
        time.sleep(1.5)
        print("| Čo chceš robiť?                                         |")
        time.sleep(0.3)
        print("| 1 - preklad textu do morzeovky                          |")
        time.sleep(0.3)
        print("| 2 - preklad morzeovky do textu                          |")
        time.sleep(0.3)
        print("| 3 - opustiť program                                     |")
        time.sleep(0.3)
        print("==========================================================")
        select = input("* Vaša voľba (1/2/3): ")
        if select == '1':
            while True:
                os.system('cls')
                text_sprava = input("* Zadaj správu (v latinke bez diakritiky): ")
                morse_sprava = text_do_morse(text_sprava)
                time.sleep(0.3)
                print("==========================================================")
                print(f'Správa v morzeovke (môžeš použiť klávesové skratky): {morse_sprava}')
                print("==========================================================")
                select = input("* Chceš sa vrátiť do menu alebo napísať novú správu? (v/p) ")
                if select == "v":
                    os.system('cls')
                    main()
                elif select == "p":
                    continue
                else:
                    os.system('cls')
                    print("__________________________________________________________")
                    print("! Nesprávny znak! Zadajte písmeno 'v' alebo písmeno 'p'  !")
                    print("==========================================================")
                    continue

        elif select == '2':
            while True:
                os.system('cls')
                morse_sprava = input("Zadaj správu v morzeovke: ")
                text_sprava = morse_do_text(morse_sprava)
                time.sleep(0.3)
                print("==========================================================")
                print(f'Správa v latinke (môžeš použiť klávesové skratky): {text_sprava}')
                print("==========================================================")
                select = input("Chceš sa vrátiť do menu alebo napísať novú správu? (v/p) ")
                if select == "v":
                    os.system('cls')
                    main()
                elif select == "p":
                    continue
                else:
                    os.system('cls')
                    print("__________________________________________________________")
                    print("! Nesprávny znak! Zadajte písmeno 'v' alebo písmeno 'p'  !")
                    print("==========================================================")
                    continue

        elif select == '3':
            os.system('cls')
            select = input("Chceš ukončiť program? (a/n) ")
            if select == "a":
                tips = [
                    "Tip: Môžeš kopírovať text pomocou klávesovej skratky: CTRL+C",
                    "Tip: Môžeš vložiť text pomocou klávesovej skratky: CTRL+V",
                    "Tip: Môžeš používať interpunkčné znamienka, ale nepoužívaj diakritické znamienka!"
                ]
                print(random.choice(tips))
                time.sleep(7)
                exit()
            elif select == "n":
                main()
            else:
                print("__________________________________________________________")
                print("! Nesprávny znak! Zadajte písmeno 'a' alebo písmeno 'n'  !")
                print("==========================================================")
                time.sleep(5)

        else:
            print("__________________________________________________________")
            print("Nesprávny znak! Zadajte volbu '1' alebo '2' alebo '3'")
            print("==========================================================")
            time.sleep(5)


main()
